import { validateUuid } from "../inputValidation/inputValidation";
import { UserV2_RegistrationResponse } from "../types/user/UserTypesV2";
import { BaseOwlBoardClient } from "./client";

export class UserClientV2 {
    private client: BaseOwlBoardClient;

    constructor(client: BaseOwlBoardClient) {
        this.client = client;
    }

    async getUser(uuid: string): Promise<UserV2_RegistrationResponse> {
        validateUuid(uuid);
        const path = `/api/v2/user/${uuid}`;
        return this.client.makeRequest("GET", path);
    }

    async checkAuth(): Promise<any> {
        const path = '/api/v2/checkAuth'
        return this.client.makeRequest("GET", path);
    }
}